package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.QJ;
import com.sa.ibiz.demo.demo.service.QJService;
import com.sa.ibiz.demo.demo.service.dto.QJSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/qj")
public class QJResource
{
	@Autowired
	private QJService service;


	@PostMapping(value = "/update")
	public ResponseEntity<QJ> update(@Validated @RequestBody QJ data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("请假[update]操作发生错误","QJ",data.getQjid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<QJ> get(@Validated @PathVariable String id){
		QJ data=new QJ();
		data.setQjid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("请假[get]操作发生错误","QJ",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<QJ> checkKey(@Validated @RequestBody QJ data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("请假[checkKey]操作发生错误","QJ",data.getQjid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<QJ> create(@Validated @RequestBody QJ data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("请假[create]操作发生错误","QJ",data.getQjid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<QJ> remove(@Validated @RequestBody QJ data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("请假[remove]操作发生错误","QJ",data.getQjid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<QJ> getDraft(@Validated @RequestBody QJ data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("请假[getDraft]操作发生错误","QJ","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<QJ>> searchDefaultPage(@Validated @RequestBody QJSearchFilter filter){
		Page<QJ> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<QJ>> listDefault(@Validated @RequestBody QJSearchFilter filter){
		List<QJ> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
